
/* This code is generated. Change template, not this */
#ifndef __HEADER_dvbsi_parser
#define __HEADER_dvbsi_parser

#include "mpsys.h"

#define DVB_MAX_SECTION_LENGTH 4096	/* EIT, otherwise 1024 */

typedef struct network_information_st
{

	int table_id;

	int network_id;

	int version_number;
	int current_next_indicator;
	int section_number;
	int last_section_number;

	buffer_iter descriptors;

	int transports_count;
	struct network_information_transports_st
	{

		int transport_stream_id;
		int original_network_id;

		buffer_iter descriptors;

	}
	transports[DVB_MAX_SECTION_LENGTH / 6];

}
network_information;

int network_information_parsable (buffer *);
char *network_information_parsable_error (buffer *);
void network_information_skip (buffer_iter *);
void network_information_parse (network_information *, buffer *);
void network_information_print (network_information *, FILE *);
void network_information_parse_and_print (buffer *, FILE *);

typedef struct bouquet_association_st
{

	int table_id;

	int bouquet_id;

	int version_number;
	int current_next_indicator;
	int section_number;
	int last_section_number;

	buffer_iter descriptors;

	int transports_count;
	struct bouquet_association_transports_st
	{

		int transport_stream_id;
		int original_network_id;

		buffer_iter descriptors;

	}
	transports[DVB_MAX_SECTION_LENGTH / 6];

}
bouquet_association;

int bouquet_association_parsable (buffer *);
char *bouquet_association_parsable_error (buffer *);
void bouquet_association_skip (buffer_iter *);
void bouquet_association_parse (bouquet_association *, buffer *);
void bouquet_association_print (bouquet_association *, FILE *);
void bouquet_association_parse_and_print (buffer *, FILE *);

typedef struct service_description_st
{

	int table_id;

	int transport_stream_id;

	int version_number;
	int current_next_indicator;
	int section_number;
	int last_section_number;
	int original_network_id;

	int services_count;
	struct service_description_services_st
	{

		int service_id;

		int eit_schedule_flag;
		int eit_present_following_flag;
		int running_status;
		int free_ca_mode;

		buffer_iter descriptors;

	}
	services[DVB_MAX_SECTION_LENGTH / 5];

}
service_description;

int service_description_parsable (buffer *);
char *service_description_parsable_error (buffer *);
void service_description_skip (buffer_iter *);
void service_description_parse (service_description *, buffer *);
void service_description_print (service_description *, FILE *);
void service_description_parse_and_print (buffer *, FILE *);

typedef struct event_information_st
{

	int table_id;

	int service_id;

	int version_number;
	int current_next_indicator;
	int section_number;
	int last_section_number;
	int transport_stream_id;
	int original_network_id;
	int segment_last_section_number;
	int last_table_id;

	int events_count;
	struct event_information_events_st
	{

		int event_id;
		int start_time_mjd;
		int start_time_hour;
		int start_time_minute;
		int start_time_second;
		int duration;
		int running_status;
		int free_ca_mode;

		buffer_iter descriptors;

	}
	events[DVB_MAX_SECTION_LENGTH / 12];

}
event_information;

int event_information_parsable (buffer *);
char *event_information_parsable_error (buffer *);
void event_information_skip (buffer_iter *);
void event_information_parse (event_information *, buffer *);
void event_information_print (event_information *, FILE *);
void event_information_parse_and_print (buffer *, FILE *);

typedef struct time_date_section_st
{

	int utc_mjd;
	int utc_hour;
	int utc_minute;
	int utc_seconds;

}
time_date_section;

int time_date_section_parsable (buffer *);
char *time_date_section_parsable_error (buffer *);
void time_date_section_skip (buffer_iter *);
void time_date_section_parse (time_date_section *, buffer *);
void time_date_section_print (time_date_section *, FILE *);
void time_date_section_parse_and_print (buffer *, FILE *);

typedef struct time_offset_table_st
{

	int utc_mjd;
	int utc_hour;
	int utc_minute;
	int utc_seconds;

	buffer_iter descriptors;

}
time_offset_table;

int time_offset_table_parsable (buffer *);
char *time_offset_table_parsable_error (buffer *);
void time_offset_table_skip (buffer_iter *);
void time_offset_table_parse (time_offset_table *, buffer *);
void time_offset_table_print (time_offset_table *, FILE *);
void time_offset_table_parse_and_print (buffer *, FILE *);

typedef struct running_status_st
{

	int streams_count;
	struct running_status_streams_st
	{

		int transport_stream_id;
		int original_network_id;
		int service_id;
		int event_id;

		int running_status;

	}
	streams[DVB_MAX_SECTION_LENGTH / 9];

}
running_status;

int running_status_parsable (buffer *);
char *running_status_parsable_error (buffer *);
void running_status_skip (buffer_iter *);
void running_status_parse (running_status *, buffer *);
void running_status_print (running_status *, FILE *);
void running_status_parse_and_print (buffer *, FILE *);

typedef struct adaptation_field_st
{

	int adaptation_field_data_identifier;

}
adaptation_field;

int adaptation_field_parsable (buffer *);
char *adaptation_field_parsable_error (buffer *);
void adaptation_field_skip (buffer_iter *);
void adaptation_field_parse (adaptation_field *, buffer *);
void adaptation_field_print (adaptation_field *, FILE *);
void adaptation_field_parse_and_print (buffer *, FILE *);

typedef struct ancillary_data_st
{

	int ancillary_data_identifier;

}
ancillary_data;

int ancillary_data_parsable (buffer *);
char *ancillary_data_parsable_error (buffer *);
void ancillary_data_skip (buffer_iter *);
void ancillary_data_parse (ancillary_data *, buffer *);
void ancillary_data_print (ancillary_data *, FILE *);
void ancillary_data_parse_and_print (buffer *, FILE *);

typedef struct bouquet_name_st
{

	buffer_iter name;

}
bouquet_name;

int bouquet_name_parsable (buffer *);
char *bouquet_name_parsable_error (buffer *);
void bouquet_name_skip (buffer_iter *);
void bouquet_name_parse (bouquet_name *, buffer *);
void bouquet_name_print (bouquet_name *, FILE *);
void bouquet_name_parse_and_print (buffer *, FILE *);

typedef struct ca_identifier_st
{

	int ids_count;
	struct ca_identifier_ids_st
	{

		int ca_system_id;

	}
	ids[DVB_MAX_SECTION_LENGTH / 2];

}
ca_identifier;

int ca_identifier_parsable (buffer *);
char *ca_identifier_parsable_error (buffer *);
void ca_identifier_skip (buffer_iter *);
void ca_identifier_parse (ca_identifier *, buffer *);
void ca_identifier_print (ca_identifier *, FILE *);
void ca_identifier_parse_and_print (buffer *, FILE *);

typedef struct cell_frequency_link_st
{

	int cells_count;
	struct cell_frequency_link_cells_st
	{

		int cell_id;
		int frequency;

		buffer_iter subcells;

	}
	cells[DVB_MAX_SECTION_LENGTH / 7];

}
cell_frequency_link;

int cell_frequency_link_parsable (buffer *);
char *cell_frequency_link_parsable_error (buffer *);
void cell_frequency_link_skip (buffer_iter *);
void cell_frequency_link_parse (cell_frequency_link *, buffer *);
void cell_frequency_link_print (cell_frequency_link *, FILE *);
void cell_frequency_link_parse_and_print (buffer *, FILE *);

typedef struct cell_list_st
{

	int cells_count;
	struct cell_list_cells_st
	{

		int cell_id;
		int cell_latitude;
		int cell_longitude;
		int cell_extend_of_latitude;
		int cell_extend_of_longitude;

		buffer_iter subcells;

	}
	cells[DVB_MAX_SECTION_LENGTH / 10];

}
cell_list;

int cell_list_parsable (buffer *);
char *cell_list_parsable_error (buffer *);
void cell_list_skip (buffer_iter *);
void cell_list_parse (cell_list *, buffer *);
void cell_list_print (cell_list *, FILE *);
void cell_list_parse_and_print (buffer *, FILE *);

typedef struct component_descriptor_st
{

	int stream_content;
	int component_type;
	int component_tag;
	int language_code;
	buffer_iter text;

}
component_descriptor;

int component_descriptor_parsable (buffer *);
char *component_descriptor_parsable_error (buffer *);
void component_descriptor_skip (buffer_iter *);
void component_descriptor_parse (component_descriptor *, buffer *);
void component_descriptor_print (component_descriptor *, FILE *);
void component_descriptor_parse_and_print (buffer *, FILE *);

typedef struct content_st
{

	int identifiers_count;
	struct content_identifiers_st
	{

		int content_nibble_1;
		int content_nibble_2;
		int user_nibble_1;
		int user_nibble_2;

	}
	identifiers[DVB_MAX_SECTION_LENGTH / 2];

}
content;

int content_parsable (buffer *);
char *content_parsable_error (buffer *);
void content_skip (buffer_iter *);
void content_parse (content *, buffer *);
void content_print (content *, FILE *);
void content_parse_and_print (buffer *, FILE *);

typedef struct country_availability_st
{

	int country_availability_flag;

	int countries_count;
	struct country_availability_countries_st
	{

		int country_code;

	}
	countries[DVB_MAX_SECTION_LENGTH / 3];

}
country_availability;

int country_availability_parsable (buffer *);
char *country_availability_parsable_error (buffer *);
void country_availability_skip (buffer_iter *);
void country_availability_parse (country_availability *, buffer *);
void country_availability_print (country_availability *, FILE *);
void country_availability_parse_and_print (buffer *, FILE *);

typedef struct data_broadcast_st
{

	int data_broadcast_id;
	int component_tag;

	int selectors_count;
	struct data_broadcast_selectors_st
	{

		int selector_byte;

	}
	selectors[DVB_MAX_SECTION_LENGTH / 1];

	int language_code;
	buffer_iter text;

}
data_broadcast;

int data_broadcast_parsable (buffer *);
char *data_broadcast_parsable_error (buffer *);
void data_broadcast_skip (buffer_iter *);
void data_broadcast_parse (data_broadcast *, buffer *);
void data_broadcast_print (data_broadcast *, FILE *);
void data_broadcast_parse_and_print (buffer *, FILE *);

typedef struct data_broadcast_id_st
{

	int data_broacast_id;

	int selectors_count;
	struct data_broadcast_id_selectors_st
	{

		int id_selector_byte;

	}
	selectors[DVB_MAX_SECTION_LENGTH / 1];

}
data_broadcast_id;

int data_broadcast_id_parsable (buffer *);
char *data_broadcast_id_parsable_error (buffer *);
void data_broadcast_id_skip (buffer_iter *);
void data_broadcast_id_parse (data_broadcast_id *, buffer *);
void data_broadcast_id_print (data_broadcast_id *, FILE *);
void data_broadcast_id_parse_and_print (buffer *, FILE *);

typedef struct cable_delivery_st
{

	int frequency;

	int fec_outer;
	int modulation;
	int symbol_rate;
	int fec_inner;

}
cable_delivery;

int cable_delivery_parsable (buffer *);
char *cable_delivery_parsable_error (buffer *);
void cable_delivery_skip (buffer_iter *);
void cable_delivery_parse (cable_delivery *, buffer *);
void cable_delivery_print (cable_delivery *, FILE *);
void cable_delivery_parse_and_print (buffer *, FILE *);

typedef struct satellite_delivery_st
{

	int frequency;
	int orbital_position;
	int west_east_flag;
	int polarization;
	int modulation;
	int symbol_rate;
	int fec_inner;

}
satellite_delivery;

int satellite_delivery_parsable (buffer *);
char *satellite_delivery_parsable_error (buffer *);
void satellite_delivery_skip (buffer_iter *);
void satellite_delivery_parse (satellite_delivery *, buffer *);
void satellite_delivery_print (satellite_delivery *, FILE *);
void satellite_delivery_parse_and_print (buffer *, FILE *);

typedef struct terrestrial_delivery_st
{

	int centre_frequency;
	int bandwidth;

	int constellation;
	int hierarchy_information;
	int code_rate_hp_stream;
	int code_rate_lp_stream;
	int guard_interval;
	int transmission_mode;
	int other_frequency_flag;

}
terrestrial_delivery;

int terrestrial_delivery_parsable (buffer *);
char *terrestrial_delivery_parsable_error (buffer *);
void terrestrial_delivery_skip (buffer_iter *);
void terrestrial_delivery_parse (terrestrial_delivery *, buffer *);
void terrestrial_delivery_print (terrestrial_delivery *, FILE *);
void terrestrial_delivery_parse_and_print (buffer *, FILE *);

typedef struct dsng_descriptor_st
{

	buffer_iter data;

}
dsng_descriptor;

int dsng_descriptor_parsable (buffer *);
char *dsng_descriptor_parsable_error (buffer *);
void dsng_descriptor_skip (buffer_iter *);
void dsng_descriptor_parse (dsng_descriptor *, buffer *);
void dsng_descriptor_print (dsng_descriptor *, FILE *);
void dsng_descriptor_parse_and_print (buffer *, FILE *);

typedef struct extended_event_st
{

	int descriptor_number;
	int last_descriptor_number;
	int language_code;

	int items_count;
	struct extended_event_items_st
	{

		buffer_iter item_description;
		buffer_iter item;

	}
	items[DVB_MAX_SECTION_LENGTH / 2];

	buffer_iter text;

}
extended_event;

int extended_event_parsable (buffer *);
char *extended_event_parsable_error (buffer *);
void extended_event_skip (buffer_iter *);
void extended_event_parse (extended_event *, buffer *);
void extended_event_print (extended_event *, FILE *);
void extended_event_parse_and_print (buffer *, FILE *);

typedef struct frequency_list_st
{

	int coding_type;

	int freqs_count;
	struct frequency_list_freqs_st
	{

		int centre_frequency;

	}
	freqs[DVB_MAX_SECTION_LENGTH / 4];

}
frequency_list;

int frequency_list_parsable (buffer *);
char *frequency_list_parsable_error (buffer *);
void frequency_list_skip (buffer_iter *);
void frequency_list_parse (frequency_list *, buffer *);
void frequency_list_print (frequency_list *, FILE *);
void frequency_list_parse_and_print (buffer *, FILE *);

typedef struct linkage_desc_st
{

	int transport_stream_id;
	int original_network_id;
	int service_id;
	int linkage_type;
	buffer_iter linkage;

}
linkage_desc;

int linkage_desc_parsable (buffer *);
char *linkage_desc_parsable_error (buffer *);
void linkage_desc_skip (buffer_iter *);
void linkage_desc_parse (linkage_desc *, buffer *);
void linkage_desc_print (linkage_desc *, FILE *);
void linkage_desc_parse_and_print (buffer *, FILE *);

typedef struct local_time_offset_st
{

	int country_code;
	int country_region_id;

	int local_time_offset_polarity;
	int local_time_offset;
	int time_of_change_mjd;
	int time_of_change_hour;
	int time_of_change_minute;
	int time_of_change_second;
	int next_time_offset;

}
local_time_offset;

int local_time_offset_parsable (buffer *);
char *local_time_offset_parsable_error (buffer *);
void local_time_offset_skip (buffer_iter *);
void local_time_offset_parse (local_time_offset *, buffer *);
void local_time_offset_print (local_time_offset *, FILE *);
void local_time_offset_parse_and_print (buffer *, FILE *);

typedef struct mosaic_st
{

	int mosaic_entry_point;
	int number_of_horizontal_element_cells;

	int number_of_vertical_element_cells;
	buffer_iter cells;

}
mosaic;

int mosaic_parsable (buffer *);
char *mosaic_parsable_error (buffer *);
void mosaic_skip (buffer_iter *);
void mosaic_parse (mosaic *, buffer *);
void mosaic_print (mosaic *, FILE *);
void mosaic_parse_and_print (buffer *, FILE *);

typedef struct multilingual_bouquet_name_st
{

	int names_count;
	struct multilingual_bouquet_name_names_st
	{

		int language_code;
		buffer_iter name;

	}
	names[DVB_MAX_SECTION_LENGTH / 4];

}
multilingual_bouquet_name;

int multilingual_bouquet_name_parsable (buffer *);
char *multilingual_bouquet_name_parsable_error (buffer *);
void multilingual_bouquet_name_skip (buffer_iter *);
void multilingual_bouquet_name_parse (multilingual_bouquet_name *, buffer *);
void multilingual_bouquet_name_print (multilingual_bouquet_name *, FILE *);
void multilingual_bouquet_name_parse_and_print (buffer *, FILE *);

typedef struct multilingual_component_st
{

	int component_tag;

	int names_count;
	struct multilingual_component_names_st
	{

		int language_code;
		buffer_iter name;

	}
	names[DVB_MAX_SECTION_LENGTH / 4];

}
multilingual_component;

int multilingual_component_parsable (buffer *);
char *multilingual_component_parsable_error (buffer *);
void multilingual_component_skip (buffer_iter *);
void multilingual_component_parse (multilingual_component *, buffer *);
void multilingual_component_print (multilingual_component *, FILE *);
void multilingual_component_parse_and_print (buffer *, FILE *);

typedef struct multilingual_network_name_st
{

	int names_count;
	struct multilingual_network_name_names_st
	{

		int language_code;
		buffer_iter network_name;

	}
	names[DVB_MAX_SECTION_LENGTH / 4];

}
multilingual_network_name;

int multilingual_network_name_parsable (buffer *);
char *multilingual_network_name_parsable_error (buffer *);
void multilingual_network_name_skip (buffer_iter *);
void multilingual_network_name_parse (multilingual_network_name *, buffer *);
void multilingual_network_name_print (multilingual_network_name *, FILE *);
void multilingual_network_name_parse_and_print (buffer *, FILE *);

typedef struct multilingual_service_name_st
{

	int names_count;
	struct multilingual_service_name_names_st
	{

		int language_code;
		buffer_iter service_provider_name;
		buffer_iter service_name;

	}
	names[DVB_MAX_SECTION_LENGTH / 5];

}
multilingual_service_name;

int multilingual_service_name_parsable (buffer *);
char *multilingual_service_name_parsable_error (buffer *);
void multilingual_service_name_skip (buffer_iter *);
void multilingual_service_name_parse (multilingual_service_name *, buffer *);
void multilingual_service_name_print (multilingual_service_name *, FILE *);
void multilingual_service_name_parse_and_print (buffer *, FILE *);

typedef struct nvod_reference_st
{

	int references_count;
	struct nvod_reference_references_st
	{

		int transport_stream_id;
		int original_network_id;
		int service_id;

	}
	references[DVB_MAX_SECTION_LENGTH / 6];

}
nvod_reference;

int nvod_reference_parsable (buffer *);
char *nvod_reference_parsable_error (buffer *);
void nvod_reference_skip (buffer_iter *);
void nvod_reference_parse (nvod_reference *, buffer *);
void nvod_reference_print (nvod_reference *, FILE *);
void nvod_reference_parse_and_print (buffer *, FILE *);

typedef struct network_name_st
{

	buffer_iter name;

}
network_name;

int network_name_parsable (buffer *);
char *network_name_parsable_error (buffer *);
void network_name_skip (buffer_iter *);
void network_name_parse (network_name *, buffer *);
void network_name_print (network_name *, FILE *);
void network_name_parse_and_print (buffer *, FILE *);

typedef struct parental_rating_st
{

	int ratings_count;
	struct parental_rating_ratings_st
	{

		int country_code;
		int rating;

	}
	ratings[DVB_MAX_SECTION_LENGTH / 4];

}
parental_rating;

int parental_rating_parsable (buffer *);
char *parental_rating_parsable_error (buffer *);
void parental_rating_skip (buffer_iter *);
void parental_rating_parse (parental_rating *, buffer *);
void parental_rating_print (parental_rating *, FILE *);
void parental_rating_parse_and_print (buffer *, FILE *);

typedef struct pdc_st
{

	int label_day;
	int label_month;
	int label_hour;
	int label_minute;

}
pdc;

int pdc_parsable (buffer *);
char *pdc_parsable_error (buffer *);
void pdc_skip (buffer_iter *);
void pdc_parse (pdc *, buffer *);
void pdc_print (pdc *, FILE *);
void pdc_parse_and_print (buffer *, FILE *);

typedef struct private_data_specifier_st
{

	int private_data_specifier;

}
private_data_specifier;

int private_data_specifier_parsable (buffer *);
char *private_data_specifier_parsable_error (buffer *);
void private_data_specifier_skip (buffer_iter *);
void private_data_specifier_parse (private_data_specifier *, buffer *);
void private_data_specifier_print (private_data_specifier *, FILE *);
void private_data_specifier_parse_and_print (buffer *, FILE *);

typedef struct short_smoothing_buffer_st
{

	int sb_size;
	int sb_leak_rate;

}
short_smoothing_buffer;

int short_smoothing_buffer_parsable (buffer *);
char *short_smoothing_buffer_parsable_error (buffer *);
void short_smoothing_buffer_skip (buffer_iter *);
void short_smoothing_buffer_parse (short_smoothing_buffer *, buffer *);
void short_smoothing_buffer_print (short_smoothing_buffer *, FILE *);
void short_smoothing_buffer_parse_and_print (buffer *, FILE *);

typedef struct service_st
{

	int service_type;
	buffer_iter provider_name;
	buffer_iter service_name;

}
service;

int service_parsable (buffer *);
char *service_parsable_error (buffer *);
void service_skip (buffer_iter *);
void service_parse (service *, buffer *);
void service_print (service *, FILE *);
void service_parse_and_print (buffer *, FILE *);

typedef struct service_availability_st
{

	int availability_flag;

	int cells_count;
	struct service_availability_cells_st
	{

		int cell_id;

	}
	cells[DVB_MAX_SECTION_LENGTH / 2];

}
service_availability;

int service_availability_parsable (buffer *);
char *service_availability_parsable_error (buffer *);
void service_availability_skip (buffer_iter *);
void service_availability_parse (service_availability *, buffer *);
void service_availability_print (service_availability *, FILE *);
void service_availability_parse_and_print (buffer *, FILE *);

typedef struct service_list_st
{

	int services_count;
	struct service_list_services_st
	{

		int service_id;
		int service_type;

	}
	services[DVB_MAX_SECTION_LENGTH / 3];

}
service_list;

int service_list_parsable (buffer *);
char *service_list_parsable_error (buffer *);
void service_list_skip (buffer_iter *);
void service_list_parse (service_list *, buffer *);
void service_list_print (service_list *, FILE *);
void service_list_parse_and_print (buffer *, FILE *);

typedef struct service_move_st
{

	int new_original_network_id;
	int new_transport_stream_id;
	int new_service_id;

}
service_move;

int service_move_parsable (buffer *);
char *service_move_parsable_error (buffer *);
void service_move_skip (buffer_iter *);
void service_move_parse (service_move *, buffer *);
void service_move_print (service_move *, FILE *);
void service_move_parse_and_print (buffer *, FILE *);

typedef struct short_event_st
{

	int language_code;
	buffer_iter event_name;
	buffer_iter text_length;

}
short_event;

int short_event_parsable (buffer *);
char *short_event_parsable_error (buffer *);
void short_event_skip (buffer_iter *);
void short_event_parse (short_event *, buffer *);
void short_event_print (short_event *, FILE *);
void short_event_parse_and_print (buffer *, FILE *);

typedef struct stream_identifier_st
{

	int component_tag;

}
stream_identifier;

int stream_identifier_parsable (buffer *);
char *stream_identifier_parsable_error (buffer *);
void stream_identifier_skip (buffer_iter *);
void stream_identifier_parse (stream_identifier *, buffer *);
void stream_identifier_print (stream_identifier *, FILE *);
void stream_identifier_parse_and_print (buffer *, FILE *);

typedef struct subtitling_st
{

	int subtitles_count;
	struct subtitling_subtitles_st
	{

		int language_code;
		int subtitling_type;
		int composition_page_id;
		int ancillary_page_id;

	}
	subtitles[DVB_MAX_SECTION_LENGTH / 8];

}
subtitling;

int subtitling_parsable (buffer *);
char *subtitling_parsable_error (buffer *);
void subtitling_skip (buffer_iter *);
void subtitling_parse (subtitling *, buffer *);
void subtitling_print (subtitling *, FILE *);
void subtitling_parse_and_print (buffer *, FILE *);

typedef struct telephone_desc_st
{

	int foreign_availability;
	int connection_type;

	int country_prefix_length;
	int intl_area_code_length;
	int operator_code_length;

	int national_area_code_length;
	int core_number_length;

	buffer_iter number;

}
telephone_desc;

int telephone_desc_parsable (buffer *);
char *telephone_desc_parsable_error (buffer *);
void telephone_desc_skip (buffer_iter *);
void telephone_desc_parse (telephone_desc *, buffer *);
void telephone_desc_print (telephone_desc *, FILE *);
void telephone_desc_parse_and_print (buffer *, FILE *);

typedef struct teletext_st
{

	int teletexts_count;
	struct teletext_teletexts_st
	{

		int language_code;
		int teletext_type;
		int teletext_magazine_number;
		int teletext_page_number;

	}
	teletexts[DVB_MAX_SECTION_LENGTH / 5];

}
teletext;

int teletext_parsable (buffer *);
char *teletext_parsable_error (buffer *);
void teletext_skip (buffer_iter *);
void teletext_parse (teletext *, buffer *);
void teletext_print (teletext *, FILE *);
void teletext_parse_and_print (buffer *, FILE *);

typedef struct time_shifted_event_st
{

	int reference_service_id;
	int reference_event_id;

}
time_shifted_event;

int time_shifted_event_parsable (buffer *);
char *time_shifted_event_parsable_error (buffer *);
void time_shifted_event_skip (buffer_iter *);
void time_shifted_event_parse (time_shifted_event *, buffer *);
void time_shifted_event_print (time_shifted_event *, FILE *);
void time_shifted_event_parse_and_print (buffer *, FILE *);

typedef struct time_shifted_service_st
{

	int reference_service_id;

}
time_shifted_service;

int time_shifted_service_parsable (buffer *);
char *time_shifted_service_parsable_error (buffer *);
void time_shifted_service_skip (buffer_iter *);
void time_shifted_service_parse (time_shifted_service *, buffer *);
void time_shifted_service_print (time_shifted_service *, FILE *);
void time_shifted_service_parse_and_print (buffer *, FILE *);

typedef struct vbi_data_st
{

	int services_count;
	struct vbi_data_services_st
	{

		int data_service_id;

		buffer_iter descriptors;

	}
	services[DVB_MAX_SECTION_LENGTH / 2];

}
vbi_data;

int vbi_data_parsable (buffer *);
char *vbi_data_parsable_error (buffer *);
void vbi_data_skip (buffer_iter *);
void vbi_data_parse (vbi_data *, buffer *);
void vbi_data_print (vbi_data *, FILE *);
void vbi_data_parse_and_print (buffer *, FILE *);

typedef struct vbi_teletext_st
{

	int teletexts_count;
	struct vbi_teletext_teletexts_st
	{

		int language_code;
		int teletext_type;
		int teletext_magazine_number;
		int teletext_page_number;

	}
	teletexts[DVB_MAX_SECTION_LENGTH / 5];

}
vbi_teletext;

int vbi_teletext_parsable (buffer *);
char *vbi_teletext_parsable_error (buffer *);
void vbi_teletext_skip (buffer_iter *);
void vbi_teletext_parse (vbi_teletext *, buffer *);
void vbi_teletext_print (vbi_teletext *, FILE *);
void vbi_teletext_parse_and_print (buffer *, FILE *);

int dvb_descriptor_parsable (buffer *);
void dvb_descriptor_parse_and_print (buffer *, FILE *);
void dvb_descriptor_loop_and_print (buffer_iter *, FILE *);

#endif
