<?xml version="1.0"?>
<x:stylesheet version='1.0' xmlns:x="http://www.w3.org/1999/XSL/Transform">
<x:output method='text'/>

<x:template match="parser">
/* This code is generated by parser.xslt. Change template, not this. */
#include "<x:value-of select="@name"/>.h"

<x:apply-templates select="group"/>

<x:apply-templates mode="checker"/>
<x:apply-templates mode="parser"/>
<x:apply-templates mode="printer"/>

</x:template>

<x:template match="group">
int <x:value-of select="@name"/>_parsable (buffer * in)
{
	assert (buffer_invariant (in));
	return (0
	<x:apply-templates select="struct" mode="group-parsable"/>
	);
}

void <x:value-of select="@name"/>_parse_and_print (buffer *in, FILE *f)
{
	<x:apply-templates select="struct" mode="group-print"/>
}

void <x:value-of select="@name"/>_loop_and_print (buffer_iter *in, FILE *f)
{
	buffer_iter iterator = *in;
	buffer buf;
	
	assert (buffer_iter_invariant (in));
	
	buf = buffer_iter_buffer_at (&amp;iterator);
	while (<x:value-of select="@name"/>_parsable (&amp;buf))
	{
		<x:apply-templates select="struct" mode="group-loop"/>
		buf = buffer_iter_buffer_at (&amp;iterator);
	}
	if (buffer_iter_available_bytes (&amp;iterator) > 0)
	{
		fprintf (f, "unparsed: ");
		buffer_iter_dump (&amp;iterator, f);
	}
	fprintf (f, "\n");
}

</x:template>

<x:template match="struct" mode="group-parsable">
	|| <x:value-of select="@name"/>_parsable (in)
</x:template>

<x:template match="struct" mode="group-print">
	if (<x:value-of select="@name"/>_parsable (in))
	{
		<x:value-of select="@name"/> parsed;
		<x:value-of select="@name"/>_parse (&amp;parsed, in);
		<x:value-of select="@name"/>_print (&amp;parsed, f);
	}
</x:template>

<x:template match="struct" mode="group-loop">
	if (<x:value-of select="@name"/>_parsable (&amp;buf))
	{
		<x:value-of select="@name"/> parsed;
		<x:value-of select="@name"/>_parse (&amp;parsed, &amp;buf);
		<x:value-of select="@name"/>_print (&amp;parsed, f);
		<x:value-of select="@name"/>_skip (&amp;iterator);
	}
</x:template>

<!-- CHECKER -->


<x:template match="struct" mode="checker">
char * <x:value-of select="@name"/>_parsable_impl (buffer_iter *iter)
{
	<x:apply-templates select="if" mode="checker_if"/>

	/* require */
	assert (buffer_iter_invariant (iter));
	
	<x:apply-templates mode="checker"/>
	
	return 0; /* OK is default */
}

int <x:value-of select="@name"/>_parsable (buffer *in)
{
	buffer_iter iterator;
	
	/* require */
	assert (buffer_invariant (in));
	
	buffer_iter_reset (&amp;iterator, in);
	return <x:value-of select="@name"/>_parsable_impl (&amp;iterator) == 0;
}

char * <x:value-of select="@name"/>_parsable_error (buffer *in)
{
	buffer_iter iterator;
	
	/* require */
	assert (buffer_invariant (in));
	
	buffer_iter_reset (&amp;iterator, in);
	return <x:value-of select="@name"/>_parsable_impl (&amp;iterator);
}

void <x:value-of select="@name"/>_skip (buffer_iter *iter)
{
	assert (buffer_iter_invariant (iter));
	/*assert (<x:value-of select="@name"/>_parsable (buffer_from (iter));*/

	<x:value-of select="@name"/>_parsable_impl (iter);
}

</x:template>

<x:template match="if" mode="checker_if">int conditional_<x:value-of select="@name"/>;
</x:template>

<x:template match="filler" mode="checker">
	/* <x:value-of select="@name"/> */
	if (buffer_iter_available_bits (iter) &lt; <x:value-of select="@bits"/>)
		return "too short for <x:value-of select="@name"/>";
	buffer_iter_skip_bits (iter, <x:value-of select="@bits"/>);
</x:template>

<x:template match="int|bcd" mode="checker">
	/* <x:value-of select="@name"/> */
	if (buffer_iter_available_bits (iter) &lt; <x:value-of select="@bits"/>)
		return "too short for <x:value-of select="@name"/>";
	<x:choose>
		<x:when test="(parent::*/if/@name) = @name">
	conditional_<x:value-of select="@name"/> = buffer_iter_int_forth (iter, <x:value-of select="@bits"/>);
		</x:when>
		<x:otherwise>
	buffer_iter_skip_bits (iter, <x:value-of select="@bits"/>);
		</x:otherwise>
	</x:choose>
</x:template>

<x:template match="isolang" mode="checker">
	/* <x:value-of select="@name"/> */
	if (buffer_iter_available_bits (iter) &lt; 24)
		return "too short for <x:value-of select="@name"/>";
	buffer_iter_skip_bits (iter, 24);
</x:template>

<x:template match="constant" mode="checker">
	/* constant <x:value-of select="@name"/> */
	if (buffer_iter_available_bits (iter) &lt; <x:value-of select="@bits"/>)
		return "too short for <x:value-of select="@name"/>";
	if (buffer_iter_int_forth (iter, <x:value-of select="@bits"/>) !=  <x:value-of select="@value"/>)
		return "expected <x:value-of select="@value"/> for <x:value-of select="@name"/>";
</x:template>

<x:template match="lenstr" mode="checker">
	{
		int string_len;
		
		if (buffer_iter_available_bytes (iter) &lt; 1)
			return "too short for string length";
		string_len = buffer_iter_int_forth (iter, 8);
		if (string_len > buffer_iter_available_bytes (iter))
			return "packet too small for variable string";
		buffer_iter_skip_bytes (iter, string_len);
	}
</x:template>

<x:template match="data" mode="checker">
	assert (iter->bit_pos == 0);
	buffer_iter_skip_bytes (iter, buffer_iter_available_bytes (iter));
</x:template>

<x:template match="if" mode="checker">
	if (conditional_<x:value-of select="@name"/> == <x:value-of select="@value"/>)
	{
		<x:apply-templates select="if" mode="checker_if"/>
		<x:apply-templates mode="checker"/>
	}
</x:template>

<x:template match="length" mode="checker">
	/* length */
	{
		<x:apply-templates select="if" mode="checker_if"/>
		int length;
		buffer_iter *parent_iter = iter;
		
		if (buffer_iter_available_bits (iter) &lt; <x:value-of select="@bits"/>)
			return "too short for length";
		length = buffer_iter_int_forth (iter, <x:value-of select="@bits"/>); 
		if (length > buffer_iter_available_bytes (iter))
			return "packet too small for length-controlled section";

		{
			buffer_iter inner = *parent_iter; /* copy */
			buffer_iter *iter = &amp;inner; /* replaces parent */
			buffer_iter_truncate_bytes (iter, length);
	
			<x:if test="@crc32">
			if (buffer_iter_available_bytes (iter) &lt; 4)
				return "section too short for CRC";
			buffer_iter_truncate_bytes (iter, buffer_iter_available_bytes (iter) - 4);
			</x:if>
			<x:apply-templates mode="checker"/>
		}
		
		buffer_iter_skip_bytes (iter, length);
	}
</x:template>

<x:template match="repeat" mode="checker">
	while (buffer_iter_available_bytes (iter) > 0)
	{
		<x:apply-templates select="if" mode="checker_if"/>
		<x:apply-templates mode="checker"/>
	}
</x:template>

<!-- PARSER -->

<x:template match="struct" mode="parser">
void <x:value-of select="@name"/>_parse (<x:value-of select="@name"/> *target, buffer *in)
{
	buffer_iter iterator;
	buffer_iter *iter = &amp;iterator; <!-- avoid &amp;iterator everywhere -->

	/* require */
	assert (buffer_invariant (in));
	assert (<x:value-of select="@name"/>_parsable (in));
	
	buffer_iter_reset (iter, in);
	
	<x:apply-templates mode="parser"/>
}	
</x:template>


<x:template match="int" mode="parser">
	target-><x:value-of select="@name"/> = buffer_iter_int_forth (iter, <x:value-of select="@bits"/>);
</x:template>

<x:template match="bcd" mode="parser">
	target-><x:value-of select="@name"/> = buffer_iter_bcd_forth (iter, <x:value-of select="@bits"/>);
</x:template>

<x:template match="isolang" mode="parser">
	target-><x:value-of select="@name"/> = buffer_iter_int_forth (iter, 24);
</x:template>

<x:template match="constant|filler" mode="parser">
	buffer_iter_skip_bits (iter, <x:value-of select="@bits"/>); /* <x:value-of select="@name"/> */
</x:template>

<x:template match="lenstr" mode="parser">
	{
		int string_len = buffer_iter_int_forth (iter, 8);
		target-><x:value-of select="@name"/> = *iter; /* copy */
		buffer_iter_truncate_bytes (&amp;(target-><x:value-of select="@name"/>), string_len);
		buffer_iter_skip_bytes (iter, string_len);
	}
</x:template>

<x:template match="data" mode="parser">
	assert (iter->bit_pos == 0);
	target-><x:value-of select="@name"/> = *iter;
</x:template>

<x:template match="if" mode="parser">
	if (target-><x:value-of select="@name"/> == <x:value-of select="@value"/>)
	{
		<x:apply-templates mode="parser"/>
	}
</x:template>

<x:template match="length" mode="parser">
	/* length */
	{
		int length;
		buffer_iter *parent_iter = iter;
		
		length = buffer_iter_int_forth (iter, <x:value-of select="@bits"/>); 

		{
			buffer_iter inner = *parent_iter; /* copy */
			buffer_iter *iter = &amp;inner; /* replaces parent */
			buffer_iter_truncate_bytes (iter, length);
	
			<x:if test="@crc32">
			buffer_iter_truncate_bytes (iter, buffer_iter_available_bytes (iter) - 4);
			</x:if>
			<x:apply-templates mode="parser"/>
		}
		
		buffer_iter_skip_bytes (iter, length);
	}
</x:template>

<x:template match="repeat" mode="parser">
	/* repeat section start */
	{
		struct <x:value-of select="ancestor::struct/@name"/>_st *parent_target = target;
		target-><x:value-of select="@name"/>_count = 0;
		
		while (buffer_iter_available_bytes (iter) > 0)
		{
			struct <x:value-of select="ancestor::struct/@name"/>_<x:value-of select="@name"/>_st *target = 
					&amp;(parent_target-><x:value-of select="@name"/>[parent_target-><x:value-of select="@name"/>_count]);

			<x:apply-templates mode="parser"/>
			(parent_target-><x:value-of select="@name"/>_count)++;
		}
	}
</x:template>

<!-- PRINTER -->

<x:template match="struct" mode="printer">
void <x:value-of select="@name"/>_print (<x:value-of select="@name"/> *target, FILE *f)
{
	/* require */
	assert (target);
	fprintf (f, "<x:value-of select="@name"/>:");
	
	<x:apply-templates mode="printer"/>
	
	fprintf (f, "\n");
}

void <x:value-of select="@name"/>_parse_and_print (buffer *in, FILE *f)
{
	<x:value-of select="@name"/> parsed;
	
	/* require */
	assert (buffer_invariant (in));
	assert (<x:value-of select="@name"/>_parsable (in));
	
	<x:value-of select="@name"/>_parse (&amp;parsed, in);
	<x:value-of select="@name"/>_print (&amp;parsed, f);
}

</x:template>

<x:template match="constant|filler" mode="printer"/>

<x:template match="int|bcd" mode="printer">
	<x:choose>
		<x:when test="@bits = 1"><!-- boolean: print name if set -->
			if (target-><x:value-of select="@name"/>) {
				fprintf (f, " <x:value-of select="@name"/>");
			}
		</x:when>
		<x:otherwise>
			fprintf (f, " <x:value-of select="@name"/> %d", target-><x:value-of select="@name"/>);
		</x:otherwise>
	</x:choose>
</x:template>

<x:template match="isolang" mode="printer">
	{
		int isolang = target-><x:value-of select="@name"/>;
		fprintf (f, " <x:value-of select="@name"/> %c%c%c", 
			(char) ((isolang >> 16) &amp; 0xFF),
			(char) ((isolang >> 8) &amp; 0xFF),
			(char) (isolang &amp; 0xFF));
	}
</x:template>

<x:template match="lenstr" mode="printer">
	{
		char str[DVB_MAX_SECTION_LENGTH+1];
		int strlen = buffer_iter_available_bytes (&amp;(target-><x:value-of select="@name"/>));
		 
		memcpy (str, buffer_iter_memory_at (&amp;(target-><x:value-of select="@name"/>)), strlen);
		str[strlen]=0;
		
		fprintf (f, " <x:value-of select="@name"/> %s", str);
	}
</x:template>

<x:template match="data" mode="printer">
	<x:choose>
		<x:when test="@printwith">
	<x:value-of select="@printwith"/> (&amp;(target-><x:value-of select="@name"/>), f);
		</x:when>
		<x:otherwise>
	fprintf (f, " <x:value-of select="@name"/> ");
	buffer_iter_dump (&amp;(target-><x:value-of select="@name"/>),f);
		</x:otherwise>
	</x:choose>
</x:template>

<x:template match="if" mode="printer">
	if (target-><x:value-of select="@name"/> == <x:value-of select="@value"/>)
	{
		<x:apply-templates mode="printer"/>
	}
</x:template>


<x:template match="length" mode="printer">
	<x:apply-templates mode="printer"/>
</x:template>

<x:template match="repeat" mode="printer">
	/* repeat section start */
	{
		int i;
		struct <x:value-of select="ancestor::struct/@name"/>_st *parent_target = target;

		for (i = 0; i &lt; target-><x:value-of select="@name"/>_count; i++)
		{
			struct <x:value-of select="ancestor::struct/@name"/>_<x:value-of select="@name"/>_st *target = 
					&amp;(parent_target-><x:value-of select="@name"/>[i]);

			<x:apply-templates mode="printer"/>
		}
	}
</x:template>

</x:stylesheet>

